unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, JPSplitter, ExtCtrls, MxCripto,Spin, Buttons;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    FileListBox: TFileListBox;
    DirectoryListBox: TDirectoryListBox;
    JPSplitter1: TJPSplitter;
    Panel3: TPanel;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Panel4: TPanel;
    Label1: TLabel;
    OuterFileName: TEdit;
    Panel5: TPanel;
    Label2: TLabel;
    OwnerName: TEdit;
    Panel6: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    BckDirectory: TEdit;
    BckFileName: TEdit;
    Panel7: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    FirstPass: TEdit;
    SecondPass: TEdit;
    SOffSetNum: TEdit;
    OffSetNum: TEdit;
    Panel8: TPanel;
    FileStatus: TLabel;
    FileOwner: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ExecutePanel: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    BackupYN: TCheckBox;
    Panel9: TPanel;
    CheckSecurity: TCheckBox;
    Label12: TLabel;
    cbEnhanced: TCheckBox;
    Label13: TLabel;
    MxCrypto: TMxCrypto;
    procedure FileListBoxClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BackupYNClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Label3DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckSecurityClick(Sender: TObject);
    procedure DirectoryListBoxChange(Sender: TObject);
    procedure cbEnhancedClick(Sender: TObject);
    procedure Label1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses FirmaFrm;

{$R *.DFM}
{$R ver.res}

procedure TMainForm.FileListBoxClick(Sender: TObject);
var Check :byte;
begin
MXCrypto.File_In:=FileListBox.FileName;
OuterFileName.Text:=ExtractFileName(FileListBox.FileName+'.Crypto');
Check:=MxCrypto.CheckLock(FileListBox.FileName);
if BackupYN.State = cbChecked then
 begin
  BckFileName.Enabled:=TRUE;
  BckDirectory.Enabled:=TRUE;
  BckFileName.Text:=ExtractFileName(FileListBox.FileName+'.Backup');
 end;
case Check of
 0:begin
    FileStatus.Caption:='File Free';
    cbEnhanced.State := cbUnChecked;
    FileOwner.Caption:='';
   end;
 1:begin
    FileStatus.Caption:='File Locked';
    if MxCrypto.Ehnanced = TRUE then 
     cbEnhanced.State := cbChecked
    else
     cbEnhanced.State := cbUnChecked;
    FileOwner.Caption:=MxCrypto.CheckOwner(FileListBox.FileName);
   end;
 2:begin
    FileStatus.Caption:='File access denied';
    cbEnhanced.State := cbUnChecked;
    FileOwner.Caption:='';
   end;
end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
BckFileName.Text:='Backup Disabled';
BckFileName.Enabled:=FALSE;
BckDirectory.Enabled:=FALSE;
MxCrypto.Security:=False;
 if MxCrypto.Ehnanced = TRUE then cbEnhanced.State := cbChecked;
   
end;

procedure TMainForm.BackupYNClick(Sender: TObject);
begin
if BackupYN.State = cbChecked then
 begin
  BckFileName.Enabled:=TRUE;
  BckDirectory.Enabled:=TRUE;
  BckFileName.Text:=ExtractFileName(FileListBox.FileName+'.Backup');
  BckDirectory.Text:=DirectoryListBox.Directory;
 end
else
 begin
  BckFileName.Enabled:=FALSE;
  BckDirectory.Enabled:=FALSE;
  BckDirectory.Text:='';
  BckFileName.Text:='Backup Disabled';
 end;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
if BackupYN.State = cbChecked then
 begin
  MxCrypto.Backup:=TRUE;
  MxCrypto.BackupDir:=BckDirectory.Text+'\';
  MxCrypto.BackupFileName:=BckFileName.Text;
 end
else
 begin
  MxCrypto.Backup:=False;
 end;
//MxCrypto.Signature:='pippo';  
MxCrypto.OffSet1:=OffSetNum.Text;
MxCrypto.OffSet2:=SOffSetNum.Text;
MxCrypto.File_In:=ExtractFileName(FileListBox.FileName);
MxCrypto.File_Out:=OuterFileName.Text;
MxCrypto.Owner:=OwnerName.Text;
MxCrypto.Password1:=FirstPass.Text;
MxCrypto.Password2:=SecondPass.Text;
MxCrypto.Execute('c');
FileListBox.Update;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
if BackupYN.State = cbChecked then
 begin
  MxCrypto.Backup:=TRUE;
  MxCrypto.BackupDir:=BckDirectory.Text+'\';
  MxCrypto.BackupFileName:=BckFileName.Text;
 end
else
 begin
  MxCrypto.Backup:=False;
 end;
//MxCrypto.Signature:='pippo'; 
MxCrypto.OffSet1:=OffSetNum.Text;
MxCrypto.OffSet2:=SOffSetNum.Text;
MxCrypto.File_In:=ExtractFileName(FileListBox.FileName);
MxCrypto.File_Out:=OuterFileName.Text;
MxCrypto.Owner:=OwnerName.Text;
MxCrypto.Password1:=FirstPass.Text;
MxCrypto.Password2:=SecondPass.Text;
MxCrypto.Execute('d');
FileListBox.Update;
end;


procedure TMainForm.Label3DblClick(Sender: TObject);
var
  Dir: string;
begin
if BackupYN.State = cbChecked then
 begin
  Dir := DirectoryListBox.Directory;
  if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
    BckDirectory.Text := Dir;
 end;
end;
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action:=caFree;
end;

procedure TMainForm.CheckSecurityClick(Sender: TObject);
begin
if CheckSecurity.State = cbChecked then MxCrypto.Security:=TRUE
else MxCrypto.Security:=False;
end;

procedure TMainForm.DirectoryListBoxChange(Sender: TObject);
begin
if BackupYN.State = cbChecked then
BckDirectory.Text:=DirectoryListBox.Directory;
end;

procedure TMainForm.cbEnhancedClick(Sender: TObject);
begin
  if cbEnhanced.State = cbChecked then 
   MxCrypto.Ehnanced:=TRUE
  else
   MxCrypto.Ehnanced:=FALSE; 
end;

procedure TMainForm.Label1DblClick(Sender: TObject);
begin
FirmaForm.Show;
end;

end.


